;| Engine Init |;
IncludePath "..\..\Source"
XIncludeFile "UBE.pbi" 

UBE_OpenScreen(1366, 768, 32, "UBE Demo", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)
UBE_ASync(#True)
UBE_ShowLogo()

UBE_SetCameraFar(256)
UBE_SetCameraFov(45)
UBE_MoveCamera(0.0, 2.0, 0.0)

UBE_SetSunStatus(#True)
UBE_SetSunColor($FFFFFFFF)
UBE_SetSunIntensity(0.0)
UBE_SetSunDirection(0.0, -1.0, 0.0)
UBE_SetAmbientColor($FF0A0A0A)

UBE_SetGlowSize(2.5)

UBE_SetGravitation(0, -9.81, 0)				

UBE_SetTextureFilter(#UBE_TEXTURE_FILTER_LINEAR)

UBE_LoadSkyBoxTexture(0, "Data\Textures\SkyBox\0.jpg") 
UBE_LoadSkyBoxTexture(1, "Data\Textures\SkyBox\1.jpg") 
UBE_LoadSkyBoxTexture(2, "Data\Textures\SkyBox\2.jpg") 
UBE_LoadSkyBoxTexture(3, "Data\Textures\SkyBox\3.jpg") 
UBE_LoadSkyBoxTexture(4, "Data\Textures\SkyBox\4.jpg") 
UBE_LoadSkyBoxTexture(5, "Data\Textures\SkyBox\5.jpg") 
UBE_GenerateSkyBox()

;| Structures |;
Structure BALL
	Object.i
	Light.i
	Time.i
EndStructure


;| Constants |;
#BALL_LIFETIME = 25000
#INFO_LIFETIME = 7500

;| Includes |;
IncludePath "Includes"
XIncludeFile "Rooms.pbi" 


;| Variables & Loadings |;
Global Time.i
Global String.s
Global ObjectCollision.i                 
Global Direction.UBE_VECTOR4f
Global bWeapon.i
Global iWeaponTimer.i
Global iWeaponColor.i
Global bFly.i
Global bJump.i
Global I.i, X.i, Y.i
Global Yaw.f, Pitch.f, Roll.f
Global MoveSpeed.f
Global iVendingMachineTimer.i
Global sInfoString.s
Global iInfoStringTime.i
Global iInfoStringID.i
Global iZoomTime.i, fZoomEffect.f

Global NewList Object_Ball.BALL()


UBE_LoadDefinition("Data\Definitions\HUD.ubd")
	UBE_LoadAllTextures() 
UBE_CloseDefinition()

UBE_LoadDefinition("Data\Definitions\Objects.ubd")
	UBE_LoadAllTextures() 
	UBE_LoadAllMaterials() 
UBE_CloseDefinition()


Global Sprite_HUD_Shadow.i							= UBE_CreateSprite(#UBE_ANY, UBE_CreateMaterial(#UBE_ANY, UBE_Texture("HUD Shadow"), #UBE_SHADER_2D_NONE))
																					UBE_ZoomSprite(Sprite_HUD_Shadow, UBE_ScreenWidth(), 96)

Global Sprite_HUD_Use.i									= UBE_CreateSprite(#UBE_ANY, UBE_CreateMaterial(#UBE_ANY, UBE_Texture("HUD Use"), #UBE_SHADER_2D_NONE))
																					UBE_ZoomSprite(Sprite_HUD_Use, 64, 64)

Global Font_Arial.i 										=	UBE_LoadFont(#UBE_ANY, "Data\Fonts\Arial.tf")

Global Mesh_VendingMachine.i						= UBE_LoadOBJMesh(#UBE_ANY, "Data\Models\Vending Machine.obj")
																					UBE_CalculateMeshTangents(Mesh_VendingMachine)	
																	
Global Mesh_Box.i												= UBE_LoadOBJMesh(#UBE_ANY, "Data\Models\Box.obj")
																					UBE_CalculateMeshTangents(Mesh_Box)																		
																	
Global Mesh_Ball.i											= UBE_LoadOBJMesh(#UBE_ANY, "Data\Models\Ball.obj")
																					UBE_CalculateMeshTangents(Mesh_Ball)																	
																	
Global Mesh_Flag.i											= UBE_LoadOBJMesh(#UBE_ANY, "Data\Models\Flag.obj")
																					UBE_CalculateMeshTangents(Mesh_Flag)																				
										
Global Mesh_Table.i											= UBE_LoadOBJMesh(#UBE_ANY, "Data\Models\Table.obj")
																					UBE_CalculateMeshTangents(Mesh_Table)																				
										 																
Global Mesh_Weapon.i										= UBE_LoadOBJMesh(#UBE_ANY, "Data\Models\Weapon.obj")
																					UBE_CalculateMeshTangents(Mesh_Weapon)																			
																	
															
;| Variables & Objects |;												
Global Object_SBVendingMachine.i				= UBE_CreateObject(#UBE_ANY, Mesh_VendingMachine, UBE_Material("SB Vending Machine"))
																					UBE_MoveObject(Object_SBVendingMachine, 0, 0, -5.7)
																					UBE_SetObjectBody(Object_SBVendingMachine, #UBE_COLLISION_BODY_BOX)
																								
Global Object_SBVendingMachineCollide.i	= UBE_CreateObject(#UBE_ANY, Mesh_VendingMachine, UBE_Material("SB Vending Machine Collide"))
																					UBE_Attachment(Object_SBVendingMachine, Object_SBVendingMachineCollide )
																					UBE_SetObjectState(Object_SBVendingMachineCollide, #False)
																				
Global Object_UBVendingMachine.i				= UBE_CreateObject(#UBE_ANY, Mesh_VendingMachine, UBE_Material("UB Vending Machine"))
																					UBE_MoveObject(Object_UBVendingMachine, -3.5, 0, -5.4)
																					UBE_RotateObject(Object_UBVendingMachine,0.0, 12.2, 0.0)
																					UBE_SetObjectBody(Object_UBVendingMachine, #UBE_COLLISION_BODY_BOX)																				
																				
Global Object_UBVendingMachineCollide.i	= UBE_CreateObject(#UBE_ANY, Mesh_VendingMachine, UBE_Material("UB Vending Machine Collide"))
																					UBE_Attachment(Object_UBVendingMachine, Object_UBVendingMachineCollide )
																					UBE_SetObjectState(Object_UBVendingMachineCollide, #False)																				
																																			
Global Object_Flag.i										= UBE_CreateObject(#UBE_ANY, Mesh_Flag, UBE_Material("Flag"))
																					UBE_MoveObject(Object_Flag, 4.999, -1.0, -2.0)
																					UBE_RotateObject(Object_Flag, 0.0, 270.0, 0.0)
																					UBE_ScaleObject(Object_Flag,2,2,2)
																																									
Global Object_Table.i										= UBE_CreateObject(#UBE_ANY, Mesh_Table, UBE_Material("Wall"))
																					UBE_MoveObject(Object_Table, -1.5, 0.0, 0.0)
																					UBE_RotateObject(Object_Table, 0.0, 90, 0.0)
																					UBE_SetObjectBody(Object_Table, #UBE_COLLISION_BODY_MESH)																		
																	
Global Object_Table.i										= UBE_CreateObject(#UBE_ANY, Mesh_Table, UBE_Material("Wall"))
																					UBE_MoveObject(Object_Table, -0.75, 0.0, 0.0)
																					UBE_RotateObject(Object_Table, 0.0, 90, 0.0)
																					UBE_SetObjectBody(Object_Table, #UBE_COLLISION_BODY_MESH)				
																					UBE_ScaleObject(Object_Table, 1.0, 0.5, 0.4)
																	
Global Object_Table.i										= UBE_CreateObject(#UBE_ANY, Mesh_Table, UBE_Material("Wall"))
																					UBE_MoveObject(Object_Table, -2.25, 0.0, 0.0)
																					UBE_RotateObject(Object_Table, 0.0, 90, 0.0)
																					UBE_SetObjectBody(Object_Table, #UBE_COLLISION_BODY_MESH)				
																					UBE_ScaleObject(Object_Table, 1.0, 0.5, 0.4)																	
																	
Global Object_Box.i											= UBE_CreateObject(#UBE_ANY, Mesh_Box, UBE_Material("Box"))
																					UBE_MoveObject(Object_Box, 2, 0.5, 0)
																					UBE_RotateObject(Object_Box, 0.0, 48.1, 0.0)
																					UBE_SetObjectBody(Object_Box, #UBE_COLLISION_BODY_BOX)	
																	
																	
Global Object_Box2.i										= UBE_CreateObject(#UBE_ANY, Mesh_Box, UBE_Material("Box"))
																					UBE_MoveObject(Object_Box2, 4, 0.5, -3)
																					UBE_RotateObject(Object_Box2, 0.0, -32.6, 0.0)
																					UBE_SetObjectBody(Object_Box2, #UBE_COLLISION_BODY_BOX)																		
																	
Global Object_Light.i										= UBE_CreateObject(#UBE_ANY, Rooms\pFloorMesh, UBE_Material("Light"))
																					UBE_MoveObject(Object_Light, -2.0, 2.99, 2.0)
																					UBE_RotateObject(Object_Light, 180.0, 0.0, 0.0)																													
Global Object_Light2.i									= UBE_CreateObject(#UBE_ANY, Rooms\pFloorMesh, UBE_Material("Light"))
																					UBE_MoveObject(Object_Light2,  9.0, 1.99, 4.0)
																					UBE_RotateObject(Object_Light2, 180.0, 0.0, 0.0)
Global Object_Light2.i									= UBE_CreateObject(#UBE_ANY, Rooms\pFloorMesh, UBE_Material("Light"))
																					UBE_MoveObject(Object_Light2,  9.0, 1.99, 5.0)
																					UBE_RotateObject(Object_Light2, 180.0, 0.0, 0.0)																	
																	
Global Object_Weapon.i									= UBE_CreateObject(#UBE_ANY, Mesh_Weapon, UBE_Material("Weapon Green"))
																					UBE_MoveObject(Object_Weapon, 0.3, -0.35, -0.5)
																					UBE_RotateObject(Object_Weapon, -10.0, 180.0, 5.0)																		
																					UBE_Attachment(UBE\Camera, Object_Weapon)	
																					UBE_SetObjectState(Object_Weapon, #False)
																	
Global Object_WeaponItem.i							= UBE_CreateObject(#UBE_ANY, Mesh_Weapon, UBE_Material("Weapon Green"))
																					UBE_MoveObject(Object_WeaponItem, 27, 0.5, 10.5)
																					
																					
Global *Object_FirstPerson.UBE_OBJECT 	= UBE_CreateObject(#UBE_ANY, Mesh_Ball, UBE_Material("Box"))
											                  	UBE_MoveObject(*Object_FirstPerson, 0, 1, 0)
											                  	UBE_ScaleObject(*Object_FirstPerson, 5, 5, 5)
											                 		UBE_SetObjectBody(*Object_FirstPerson, #UBE_COLLISION_BODY_SPHERE)
											                  	UBE_SetObjectState(*Object_FirstPerson, #False)
											                  	UBE_SetObjectMass(*Object_FirstPerson, 100)
											                 		UBE_LockMouse()																					
																					
;| Variables & Lights |;																				
Global Dim Light.i(16)													
																	
Light(0) 												= UBE_CreateLight(#UBE_ANY, 0.5, 0.5, 0.5)
																	UBE_SetLightColor(Light(0), $FFEDE2D4)
																	UBE_SetLightRange(Light(0), 10)
																	UBE_SetLightIntensity(Light(0), 0.75)														
																	UBE_Attachment(Object_Light, Light(0))
														
Light(1) 												= UBE_CreateLight(#UBE_ANY, 0, 1.0, 0.6)
																	UBE_SetLightColor(Light(1), $FF0014DA)
																	UBE_SetLightRange(Light(1), 3)
																	UBE_SetLightIntensity(Light(1), 0.8)																					
																	UBE_Attachment(Object_SBVendingMachine, Light(1))
																	
Light(2) 												= UBE_CreateLight(#UBE_ANY, 0, 1.0, 0.6)
																	UBE_SetLightColor(Light(2), $FF00D92A)
																	UBE_SetLightRange(Light(2), 2.5)
																	UBE_SetLightIntensity(Light(2), 0.75)																					
																	UBE_Attachment(Object_UBVendingMachine, Light(2))																	
																																	
Light(3)  											= UBE_CreateLight(#UBE_ANY, -0.55, 0.4, 0.2)
																	UBE_SetLightColor(Light(3), $FF00CD18)
																	UBE_SetLightRange(Light(3), 1.3)
																	UBE_SetLightIntensity(Light(3), 0.6)	
																	UBE_Attachment(Object_Box, Light(3))																			
																	
Light(3)  											= UBE_CreateLight(#UBE_ANY, -0.55, 0.4, 0.2)
																	UBE_SetLightColor(Light(3), $FF00CD18)
																	UBE_SetLightRange(Light(3), 1.3)
																	UBE_SetLightIntensity(Light(3), 0.6)	
																	UBE_Attachment(Object_Box2, Light(3))																								
																	
Light(6) 												= UBE_CreateLight(#UBE_ANY, 0, -0.2, 0.5)
																	UBE_SetLightColor(Light(6), $FF3BFC22)
																	UBE_SetLightRange(Light(6), 0.75)
																	UBE_SetLightIntensity(Light(6), 0.6)														
																	UBE_Attachment(Object_Weapon, Light(6))															
																	UBE_SetLightStatus(Light(6), #False)
																																		
Light(7) 												= UBE_CreateLight(#UBE_ANY, 0.5, 0.5, 1.0)
																	UBE_SetLightColor(Light(7), $FFEDE2D4)
																	UBE_SetLightRange(Light(7), 5)
																	UBE_SetLightIntensity(Light(7), 0.9)														
																	UBE_Attachment(Object_Light2, Light(7))																																														
																	
Light(9) 												= UBE_CreateLight(#UBE_ANY, 0, -0.2, 0.5)
																	UBE_SetLightColor(Light(9), $FF3BFC22)
																	UBE_SetLightRange(Light(9), 0.75)
																	UBE_SetLightIntensity(Light(9), 0.6)														
																	UBE_Attachment(Object_WeaponItem, Light(9) )		

																	
;| Variables & Particles |;																			
Global Particles_Dust.i      		= UBE_LoadParticleEmitter(#UBE_ANY, "Data\Definitions\SingleDust.ubd")
																	UBE_SetMaterialBlendingMode(UBE_GetParticleEmitterMaterial(Particles_Dust), #UBE_BLENDMODE_SRC_ALPHA, #UBE_BLENDMODE_ONE_MINUS_SRC_ALPHA )
																	UBE_MoveParticleEmitter(Particles_Dust, 0.5, 1.25, 0.5)
																	UBE_Attachment(Object_Light, Particles_Dust)
																													
Global Particles_Steam.i      	= UBE_LoadParticleEmitter(#UBE_ANY, "Data\Definitions\Steam.ubd")
																	UBE_SetMaterialBlendingMode(UBE_GetParticleEmitterMaterial(Particles_Steam), #UBE_BLENDMODE_SRC_ALPHA, #UBE_BLENDMODE_ONE_MINUS_SRC_ALPHA )
																	UBE_MoveParticleEmitter(Particles_Steam, 12.5, 2.0, 3.5)
																														


;| Sounds |;
Global Sound_Channel
Global Sound_Steam							= UBE_LoadSoundFile(#UBE_ANY, "Data\Sounds\Steam.ogg", #UBE_SOUND_LOOP|#UBE_SOUND_PLAY)
																	UBE_SoundRange(Sound_Steam, 0, 10)
																	UBE_SoundCone(Sound_Steam, 45, 90)
																	UBE_SoundDirection(Sound_Steam, -2, -1, 1.5)
																	UBE_Attachment(UBE_ParticleEmitterID(Particles_Steam), UBE_SoundID(Sound_Steam))

Global Sound_Freezer						= UBE_LoadSoundFile(#UBE_ANY, "Data\Sounds\Freezer.ogg", #UBE_SOUND_LOOP|#UBE_SOUND_CHANNEL)
																	UBE_SoundRange(Sound_Freezer, 1, 5)
																	Sound_Channel = UBE_PlaySound(Sound_Freezer)
																	UBE_Attachment(UBE_ParticleEmitterID(Object_SBVendingMachine), UBE_SoundID(Sound_Channel))
																	Sound_Channel = UBE_PlaySound(Sound_Freezer)
																	UBE_Attachment(UBE_ParticleEmitterID(Object_UBVendingMachine), UBE_SoundID(Sound_Channel))
																	
Global Sound_Light							= UBE_LoadSoundFile(#UBE_ANY, "Data\Sounds\Light.ogg", #UBE_SOUND_CHANNEL)
																	UBE_SoundRange(Sound_Light, 5, 10)
																	
Global Sound_Hit								= UBE_LoadSoundFile(#UBE_ANY, "Data\Sounds\Hit.ogg", #UBE_SOUND_CHANNEL)
																	UBE_SoundRange(Sound_Hit, 0, 5)

Global Sound_Door							= UBE_LoadSoundFile(#UBE_ANY, "Data\Sounds\Door.ogg", #UBE_SOUND_CHANNEL)
																	UBE_SoundRange(Sound_Door, 5, 10)
Global Sound_Shot							= UBE_LoadSoundFile(#UBE_ANY, "Data\Sounds\Shot.ogg", #UBE_SOUND_CHANNEL)
																	UBE_SoundVolume(Sound_Shot, 0.4)

Global Sound_Hit2							= UBE_LoadSoundFile(#UBE_ANY, "Data\Sounds\Hit2.ogg", #UBE_SOUND_CHANNEL)
																	UBE_SoundRange(Sound_Hit2, 5, 20)
																	UBE_SoundVolume(Sound_Hit2, 0.4)


UBE_AddCollisionSound(Sound_Hit, UBE_Material("SB Ball"))
UBE_AddCollisionSound(Sound_Hit, UBE_Material("UB Ball"))


;| Create Rooms |;																	
CreateRoom(0, "Data\Rooms\Test.txt")															
CreateRoom(1, "Data\Rooms\Test 2.txt",10,6)
CreateRoom(2, "Data\Rooms\Test 3.txt",22,10)																																	
																	

Global Flicker = ElapsedMilliseconds()
Global MyMatrix.UBE_MATRIX4f

;| MainLoop |;	
Repeat
	
	Repeat 
		Select UBE_WindowEvent()
			Case #PB_Event_CloseWindow
				Break 2
			Case #PB_Event_None
				Break
		EndSelect
	ForEver
	
	
	;| Examines ;|
	UBE_ExamineKeyboard()
	UBE_ExamineMouse()
	UBE_ExamineParticleEmitters()
	UBE_ExamineSounds()
	UBE_ExaminePhysics()
	
	Time = ElapsedMilliseconds()
	
	If Flicker < Time
		Flicker = ElapsedMilliseconds() + 100+Random(3000)
		UBE_Attachment(UBE_ObjectID(Object_Light), UBE_SoundID(UBE_PlaySound(Sound_Light)))
	EndIf
	Define Factor.f = -(Time-Flicker)*0.02
	UBE_SetLightIntensity(Light(0), 0.75*(1-0.5*Exp(-(Factor-2)*(Factor-2))) )
	
	ForEach Object_Ball()
		
		If Object_Ball()\Time < Time
			UBE_FreeObject(Object_Ball()\Object)
			UBE_FreeLight(Object_Ball()\Light)
			DeleteElement(Object_Ball())
		EndIf

	Next
	

	;| Control ;|	
	If bFly
		
		If UBE_KeyboardPushed(#UBE_KEY_SHIFT)
				MoveSpeed.f = UBE_TimeFactor()*20
		Else
				MoveSpeed.f = UBE_TimeFactor()*10
			EndIf
			
		If UBE_MouseButtonPushed(#UBE_MOUSEBUTTON_RIGHT)
			Yaw 		- UBE_MouseDeltaX()*0.4
			Pitch 	= UBE_fClamp(Pitch - UBE_MouseDeltaY()*0.2, -70, 70)
		  UBE_RotateCamera(0, Yaw, 0, #UBE_ABSOLUTE|#UBE_WORLD)
		  UBE_RotateCamera(Pitch, 0, 0, #UBE_RELATIVE|#UBE_LOCAL)
		EndIf

		If UBE_KeyboardPushed(#UBE_KEY_W)
			UBE_MoveCamera(0, 0, -MoveSpeed, #UBE_RELATIVE|#UBE_LOCAL)
		ElseIf UBE_KeyboardPushed(#UBE_KEY_S)
	  	UBE_MoveCamera(0, 0, MoveSpeed, #UBE_RELATIVE|#UBE_LOCAL)
		EndIf
	 	If UBE_KeyboardPushed(#UBE_KEY_A)
	  	UBE_MoveCamera( -MoveSpeed, 0, 0, #UBE_RELATIVE|#UBE_LOCAL)
	 	ElseIf UBE_KeyboardPushed(#UBE_KEY_D)
	  	UBE_MoveCamera( MoveSpeed, 0, 0, #UBE_RELATIVE|#UBE_LOCAL)
		EndIf

	Else	
	  Yaw   - UBE_MouseDeltaX()*0.4
	  Pitch  = UBE_fClamp(Pitch - UBE_MouseDeltaY()*0.2, -70, 70)
	   UBE_RotateObject(*Object_FirstPerson, 0, Yaw, 0, #UBE_ABSOLUTE|#UBE_WORLD)
	   UBE_RotateObject(*Object_FirstPerson, Pitch, 0, 0, #UBE_RELATIVE|#UBE_LOCAL)
	   UBE_SetCameraRotation(*Object_FirstPerson\qRotation)
	   UBE_SetCameraPosition(*Object_FirstPerson\v4fPosition)
	   UBE_MoveCamera(0, 1, 0, #UBE_RELATIVE)
	   *Object_FirstPerson\Body\v4fVelocity\X = 0
	   *Object_FirstPerson\Body\v4fVelocity\Z = 0

		 If UBE_KeyboardPushed(#UBE_KEY_SHIFT)
		   MoveSpeed.f = UBE_TimeFactor()*8
		 Else
		   MoveSpeed.f = UBE_TimeFactor()*5
		 EndIf

			UBE_v4fCopy(Direction, UBE_GetCameraDirection())
			Direction\Y = 0
			UBE_v4fNormalize(Direction)
			If UBE_KeyboardPushed(#UBE_KEY_W)
			 	UBE_MoveObject(*Object_FirstPerson, Direction\X*MoveSpeed, 0, Direction\Z*MoveSpeed, #UBE_RELATIVE|#UBE_WORLD)
			 	Roll + MoveSpeed
			ElseIf UBE_KeyboardPushed(#UBE_KEY_S)
			  UBE_MoveObject(*Object_FirstPerson, -Direction\X*MoveSpeed, 0, -Direction\Z*MoveSpeed, #UBE_RELATIVE|#UBE_WORLD)
			  Roll + MoveSpeed
			EndIf
			 If UBE_KeyboardPushed(#UBE_KEY_A)
			  UBE_MoveObject(*Object_FirstPerson, Direction\Z*MoveSpeed, 0, -Direction\X*MoveSpeed, #UBE_RELATIVE|#UBE_WORLD)
			  Roll + MoveSpeed
			ElseIf UBE_KeyboardPushed(#UBE_KEY_D)
			  UBE_MoveObject(*Object_FirstPerson, -Direction\Z*MoveSpeed, 0, Direction\X*MoveSpeed, #UBE_RELATIVE|#UBE_WORLD)
			  Roll + MoveSpeed
			EndIf
			If UBE_KeyboardReleased(#UBE_KEY_SPACE) 
			  UBE_MoveObject(*Object_FirstPerson, 0, 0.1, 0, #UBE_RELATIVE)
			  UBE_SetObjectVelocity(*Object_FirstPerson, UBE_v4fPush(0, 5, 0, 0)) : UBE_v4fPop()
			EndIf
			
		EndIf

; 		If UBE_KeyboardReleased(#UBE_KEY_M)
; 			If bFly	
; 				UBE_LockMouse()
; 				bFly = #False
; 			Else
; 				UBE_UnLockMouse()
; 				bFly = #True
; 			EndIf
; 		EndIf

		
		If UBE_KeyboardReleased(#UBE_KEY_ESC)
			Break
		EndIf
	
	
	;| Collision ;|	
	ObjectCollision = UBE_PointCollide(UBE_MouseX(), UBE_MouseY())
	
	
	;| Word ;|	
	
	If iInfoStringTime < Time
		If iInfoStringID = 0
			sInfoString 			= "Use [W][A][S][D] to move!"
			iInfoStringTime 	= Time + 2*#INFO_LIFETIME
			iInfoStringID 		+ 1
			
		ElseIf iInfoStringID = 1
			sInfoString 			= "Press [Space] to jump!"
			iInfoStringTime 	= Time + 2*#INFO_LIFETIME
			iInfoStringID 		+ 1
			
		ElseIf iInfoStringID = 2
			sInfoString 			= "Press [Shift] to walk faster!"
			iInfoStringTime 	= Time + 2*#INFO_LIFETIME
			iInfoStringID 		+ 1
			
			
		EndIf
	EndIf
	
	
	
	ForEach Rooms\lRoom()
		ForEach Rooms\lRoom()\lDoor()
			
			With Rooms\lRoom()\lDoor()
				
				If UBE_v3fDistance(UBE\Camera\v4fPosition, Rooms\lRoom()\lDoor()) <= 3.0
					If \bStatus = 0 
						UBE_MoveSound(UBE_PlaySound(Sound_Door), \X, \Y, \Z)
						\bStatus = 1
					EndIf
					Select \fRotation
							
						Case 90.0
							If \v3fOffset\Z > -0.895
								\v3fOffset\Z - 2 * UBE_TimeFactor()
								If \v3fOffset\Z < -0.895
									\v3fOffset\Z = -0.895
								EndIf
								UBE_MoveObject(\iObject, \X+\v3fOffset\X, \Y, \Z+\v3fOffset\Z)
							EndIf
							
						Case 270.0
							If \v3fOffset\Z < 0.895
								\v3fOffset\Z + 2 * UBE_TimeFactor()
								If \v3fOffset\Z > 0.895
									\v3fOffset\Z = 0.895
								EndIf
								UBE_MoveObject(\iObject, \X+\v3fOffset\X, \Y, \Z+\v3fOffset\Z)
							EndIf

					EndSelect
	
				Else
					If \bStatus = 1
						UBE_MoveSound(UBE_PlaySound(Sound_Door), \X, \Y, \Z)
						\bStatus = 0
					EndIf
					Select \fRotation
							
						Case 90.0
							If \v3fOffset\Z < 0.0
								\v3fOffset\Z + 2 * UBE_TimeFactor()
								If \v3fOffset\Z > 0.0
									\v3fOffset\Z = 0.0
								EndIf
								UBE_MoveObject(\iObject, \X+\v3fOffset\X, \Y, \Z+\v3fOffset\Z)
							EndIf
							
						Case 270.0
							If \v3fOffset\Z > 0.0
								\v3fOffset\Z - 2 * UBE_TimeFactor()
								If \v3fOffset\Z < 0.0
									\v3fOffset\Z = 0.0
								EndIf
								UBE_MoveObject(\iObject, \X+\v3fOffset\X, \Y, \Z+\v3fOffset\Z)
							EndIf
					
					EndSelect
	
				EndIf
			
			EndWith
			
		Next
	Next

	If bWeapon
		
		If UBE_MouseButtonDown(#UBE_MOUSEBUTTON_RIGHT) Or UBE_MouseButtonReleased(#UBE_MOUSEBUTTON_RIGHT) 
			iZoomTime = ElapsedMilliseconds()+200
		EndIf
		
		If UBE_MouseButtonPushed(#UBE_MOUSEBUTTON_RIGHT)
			fZoomEffect = UBE_fClamp((iZoomTime-Time)/200, 0, 1)
		Else
			fZoomEffect = 1-UBE_fClamp((iZoomTime-Time)/200, 0, 1)
		EndIf
		
		UBE_MoveObject(Object_Weapon, 0.3*fZoomEffect, -0.265-0.085*fZoomEffect-Sin(Roll)*(0.005+fZoomEffect*0.015), -0.5)
		UBE_RotateObject(Object_Weapon, -4.5-5.5*fZoomEffect, 180.0, 5.0*fZoomEffect-Sin(Roll)*(0.2*1.8*fZoomEffect))
		UBE_SetCameraFov(35+10*fZoomEffect)
			
; 		
; 		If UBE_MouseButtonPushed(#UBE_MOUSEBUTTON_RIGHT)
; 			iZoomTime = ElapsedMilliseconds()
; 			UBE_MoveObject(Object_Weapon, 0.0, -0.265-Sin(Roll)*0.005, -0.5)
; 			UBE_RotateObject(Object_Weapon, -4.5, 180.0, 0.0-Sin(Roll)*0.2)
; 		Else
; 			UBE_MoveObject(Object_Weapon, 0.3, -0.35-Sin(Roll)*0.02, -0.5)
; 			UBE_RotateObject(Object_Weapon, -10.0, 180.0, 5.0-Sin(Roll)*2.0)
; 		EndIf
		
		If UBE_KeyboardReleased(#UBE_KEY_1)
			iWeaponColor = 0
			UBE_SetObjectMaterial(Object_Weapon, UBE_Material("Weapon Green"))
			UBE_SetLightColor(Light(6), $FF3DF541)
			
		ElseIf UBE_KeyboardReleased(#UBE_KEY_2)
			iWeaponColor = 1
			UBE_SetObjectMaterial(Object_Weapon, UBE_Material("Weapon Orange"))
			UBE_SetLightColor(Light(6), $FF3CA2F5)
			
		EndIf

		ForEach Object_Ball()
			If UBE_GetObjectBody(Object_Ball()\Object) = #UBE_COLLISION_BODY_POINT
				If UBE_RayCollide(UBE_ObjectPositionVector(Object_Ball()\Object), UBE_v4fScale(UBE_v4fPushCopy(UBE_GetObjectVelocity(Object_Ball()\Object)), UBE_TimeFactor()*4), #False) <> #UBE_ANY
					UBE_MoveObject(Object_Ball()\Object, UBE_CollisionPositionX(), UBE_CollisionPositionY(), UBE_CollisionPositionZ())
					UBE_MoveLight(Object_Ball()\Light, UBE_CollisionNormalX()*0.15, UBE_CollisionNormalY()*0.15, UBE_CollisionNormalZ()*0.15)
					UBE_SetObjectBody(Object_Ball()\Object, #UBE_COLLISION_BODY_NONE)
					UBE_MoveSound(UBE_PlaySound(Sound_Hit2), UBE_CollisionPositionX(), UBE_CollisionPositionY(), UBE_CollisionPositionZ())
				EndIf
				UBE_v4fPop()
			EndIf
		Next
		
		If UBE_MouseButtonPushed(#UBE_MOUSEBUTTON_LEFT) And iWeaponTimer < Time
			AddElement(Object_Ball())
			UBE_MoveSound(UBE_PlaySound(Sound_Shot), UBE_CameraPositionX()+UBE_CameraDirectionX(), UBE_CameraPositionY()+UBE_CameraDirectionY(), UBE_CameraPositionZ()+UBE_CameraDirectionZ())
			If iWeaponColor = 0
				Object_Ball()\Object	= UBE_CreateObject(#UBE_ANY, Mesh_Ball, UBE_Material("Bullet Green"))
																UBE_SetObjectBody(Object_Ball()\Object, #UBE_COLLISION_BODY_POINT)
																UBE_SetObjectMass(Object_Ball()\Object, 1)
																UBE_SetObjectVelocity(Object_Ball()\Object, UBE_v4fPush(UBE_CameraDirectionX()*20, UBE_CameraDirectionY()*20, UBE_CameraDirectionZ()*20)) : UBE_v4fPop()
				
				Object_Ball()\Light		=	UBE_CreateLight(#UBE_ANY, 0, 0, 0)								
																UBE_SetLightColor(Object_Ball()\Light, $FF3DF541)
																UBE_SetLightRange(Object_Ball()\Light, 1.0)
																UBE_SetLightIntensity(Object_Ball()\Light, 0.9)
																UBE_Attachment(Object_Ball()\Object, Object_Ball()\Light)
																
			ElseIf iWeaponColor = 1
																
				Object_Ball()\Object	= UBE_CreateObject(#UBE_ANY, Mesh_Ball, UBE_Material("Bullet Orange"))			
																UBE_SetObjectBody(Object_Ball()\Object, #UBE_COLLISION_BODY_POINT)
																UBE_SetObjectMass(Object_Ball()\Object, 1)
																UBE_SetObjectVelocity(Object_Ball()\Object, UBE_v4fPush(UBE_CameraDirectionX()*20, UBE_CameraDirectionY()*20, UBE_CameraDirectionZ()*20)) : UBE_v4fPop()
								
				Object_Ball()\Light		=	UBE_CreateLight(#UBE_ANY, 0, 0, 0)
																UBE_SetLightColor(Object_Ball()\Light, $FF3CA2F5)
																UBE_SetLightRange(Object_Ball()\Light, 1.0)
																UBE_SetLightIntensity(Object_Ball()\Light, 0.9)
																UBE_Attachment(Object_Ball()\Object, Object_Ball()\Light)
																
			EndIf
			
			UBE_ToWorldMatrix(MyMatrix, Object_Weapon)
			;UBE_m4fDebug(MyMatrix)
			UBE_SetObjectPosition(Object_Ball()\Object, UBE_v4fMultiplyByMatrix4f(UBE_v4fPush(0, 0.15, 0.9), MyMatrix)) : UBE_v4fPop()
			
			Object_Ball()\Time		= Time + #BALL_LIFETIME			

			iWeaponTimer 					= ElapsedMilliseconds() + 150
		EndIf
		
	Else
		UBE_RotateObject(Object_WeaponItem, 0, 15*UBE_TimeFactor(), 0, #UBE_RELATIVE)	
		
		If UBE_v3fDistance(UBE\Camera\v4fPosition, UBE_ObjectPositionVector(Object_WeaponItem)) < 1.5 
			UBE_SetObjectState(Object_WeaponItem, #False)
			UBE_SetObjectState(Object_Weapon, #True)
			UBE_SetLightStatus(Light(9), #False)
			UBE_SetLightStatus(Light(6), #True)
			bWeapon 					= #True
			sInfoString 			= "To switch between green and orange press [1] or [2]!"
			iInfoStringTime 	= Time + #INFO_LIFETIME
		EndIf
	
	EndIf
	
	String = ""
	
	If ObjectCollision = Object_SBVendingMachine And UBE_v3fDistance(UBE\Camera\v4fPosition, UBE_ObjectPositionVector(Object_SBVendingMachine)) < 5.0 
		UBE_SetObjectState(Object_SBVendingMachineCollide, #True)
		String = "Press [E] to use"
		
		
		
		If UBE_KeyboardReleased(#UBE_KEY_E)
				
			AddElement(Object_Ball())
			Object_Ball()\Object		= UBE_CreateObject(#UBE_ANY, Mesh_Ball, UBE_Material("SB Ball"))									
																UBE_MoveObject(Object_Ball()\Object, UBE_ObjectX(Object_SBVendingMachine), UBE_ObjectY(Object_SBVendingMachine)+0.2, UBE_ObjectZ(Object_SBVendingMachine)+0.6)
																UBE_RotateObject(Object_Ball()\Object, Random(3600)*0.1, Random(3600)*0.1, Random(3600)*0.1)																	
																UBE_SetObjectBody(Object_Ball()\Object, #UBE_COLLISION_BODY_SPHERE)
																UBE_SetObjectMass(Object_Ball()\Object, 1.0)
																UBE_SetObjectFriction(Object_Ball()\Object, 0.9)
																UBE_SetObjectVelocity(Object_Ball()\Object, UBE_v4fPush(2.0-Random(40)*0.1, 2.0+Random(20)*0.1, 5.0+Random(100)*0.01, 0.0)) : UBE_v4fPop()
																
			Object_Ball()\Light			=	UBE_CreateLight(#UBE_ANY, 0.0, 0.0, 0.0)								
																UBE_SetLightColor(Object_Ball()\Light, $FF3D47F6)
																UBE_SetLightRange(Object_Ball()\Light, 1.5)
																UBE_SetLightIntensity(Object_Ball()\Light, 0.8)	
																UBE_Attachment(Object_Ball()\Object, Object_Ball()\Light)		
												
			Object_Ball()\Time			= Time + #BALL_LIFETIME			
												
		EndIf

	Else
		UBE_SetObjectState(Object_SBVendingMachineCollide, #False)
	EndIf

	If ObjectCollision = Object_UBVendingMachine And UBE_v3fDistance(UBE\Camera\v4fPosition, UBE_ObjectPositionVector(Object_UBVendingMachine)) < 5.0 
		UBE_SetObjectState(Object_UBVendingMachineCollide, #True)
		String = "Press [E] to use"

		If UBE_KeyboardReleased(#UBE_KEY_E)
				
			AddElement(Object_Ball())
			Object_Ball()\Object		= UBE_CreateObject(#UBE_ANY, Mesh_Ball, UBE_Material("UB Ball"))									
																UBE_MoveObject(Object_Ball()\Object, UBE_ObjectX(Object_UBVendingMachine)+0.15, UBE_ObjectY(Object_UBVendingMachine)+0.2, UBE_ObjectZ(Object_UBVendingMachine)+0.6)
																UBE_RotateObject(Object_Ball()\Object, Random(3600)*0.1, Random(3600)*0.1, Random(3600)*0.1)																	
																UBE_SetObjectBody(Object_Ball()\Object, #UBE_COLLISION_BODY_SPHERE)
																UBE_SetObjectMass(Object_Ball()\Object, 1.0)
																UBE_SetObjectFriction(Object_Ball()\Object, 0.9)
																UBE_SetObjectVelocity(Object_Ball()\Object, UBE_v4fPush(2.0-Random(40)*0.1, 2.0+Random(20)*0.1, 5.0+Random(100)*0.01, 0.0)) : UBE_v4fPop()
																
			Object_Ball()\Light			=	UBE_CreateLight(#UBE_ANY, 0.0, 0.0, 0.0)								
																UBE_SetLightColor(Object_Ball()\Light, $FF3DF541)
																UBE_SetLightRange(Object_Ball()\Light, 1.5)
																UBE_SetLightIntensity(Object_Ball()\Light, 0.8)	
																UBE_Attachment(Object_Ball()\Object, Object_Ball()\Light)		
												
			Object_Ball()\Time			= Time + #BALL_LIFETIME			
												
		EndIf
		
	Else
		UBE_SetObjectState(Object_UBVendingMachineCollide, #False)
	EndIf
	

	;| Rendering 3D ;|
	UBE_RenderScene()

	;| Rendering 2D ;|
	UBE_DepthTest(#False)
	
	UBE_FontAlign(Font_Arial, #UBE_FONT_ALIGN_CENTER, #UBE_FONT_ALIGN_BOTTOM)
	
	If String
		UBE_DisplaySprite(Sprite_HUD_Use, UBE_ScreenWidth()*0.5, UBE_ScreenHeight()*0.5)
		UBE_DisplayFont(Font_Arial, UBE_ScreenWidth()*0.5, UBE_ScreenHeight()*0.5-64, String, $CCFFFFFF)
	EndIf
	
	If iInfoStringTime > Time
		UBE_DisplaySprite(Sprite_HUD_Shadow, UBE_ScreenWidth()*0.5, 0)
		UBE_DisplayFont(Font_Arial, UBE_ScreenWidth()*0.5, 32, sInfoString, $FFFFFF)
	EndIf
	

	UBE_FlipBuffers()
	UBE_SetScreenTitle("UBE Demo [Engine Version: "+#UBE_VERSION+ "] - FPS: "+StrF(UBE_FPS(),2))
	
ForEver

UBE_Free()

End








; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 12
; EnableXP
; Executable = Cube.exe
; DisableDebugger
; Compiler = PureBasic 5.20 LTS (Windows - x86)
; EnableCompileCount = 350
; EnableBuildCount = 1